/*
gui-js/menu.js
This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created mar. août 30 02:24:47 CEST 2011 by whygee@f-cpu.org
version lun. sept 12 08:17:07 CEST 2011 init_obj() added
version mer. avril 11 21:36:51 CEST 2012 : console.info removed
version mer. mai  9 12:58:55 CEST 2012 : changed the argument formats.

This file implements a menu bar that can be independent from ygwm.
  some features depend on winman and avoid closure.
*/


init_obj.push(menu={
  list:{},

  unfold_menuItem: function(){
    if (ygwm.moved_div)
      return; // No display if ygwm (or dragndrop) is currently moving something
    if (this.listlength > 0)
      this.menuItemList.style.display=""; // display only if something to show
  },

  fold_menuItem: function(){
    this.menuItemList.style.display="none";
  },

  onClick: function(){
    winman.activate_window(this.key);
  },

  // langlist is a list of strings, that can be HTML to make links and pictures and stuff
  //    The first element is used as a "key" to find the entry later.
  // func can be a ygwm key string or a normal function. Leave empty if nothing.
  subMenuItem: function(n,langlist,func, sep){
//    if (typeof langlist!="object")
//      return alert("subMenuItem: expecting langlist argument to be an array");

    var name=langlist[0], l;
    if (n.list[name])
      return n.list[name]; // don't create duplicates
    var o=dcE("DIV");
    if(sep===1)
      o.className="menuSeparator";
    else
      o.className="menuItem";

    if (langlist.length > 1)
      LANG.change_innerHTML.push([o,langlist]);
    if(typeof (l=langlist[LANG.LANG]) != "string")
        l=name;
    o.innerHTML=l;

    if (typeof func == "function")
      o.onclick=func;
    else {
      if (typeof func == "string") {
        o.onclick=menu.onClick;
        o.key=func; // avoid closure
      }
    }
    n.list[name]=o;
    n.listlength++;
    n.menuItemList.appendChild(o);
    return o;
  },

  mainMenuItem: function(langlist,dir){
    if (typeof langlist=="string") {
      if (menu.list[langlist])
        return menu.list[langlist]; ////// LOOKUP SHOULD BE DONE WITH menu.list["xyz"]
      else
        Alrt(langlist+" not found",    /*TR-en*/
             langlist+" introuvable"); /*TR-fr*/
    }
    var name=langlist[0],
        m=dcE("DIV"),
        n=dcE("DIV"),
        o=dcE("SPAN"),
        i,k,l;
    if (dir != "R")
      dir="L"; // class "L" by default (left-justified unless told otherwise)
    n.className="menuBarItem"+dir;
    menu.list[name]=n;

    LANG.change_innerHTML.push([o,langlist]);
    if(typeof (l=langlist[LANG.LANG]) != "string")
      l=name;

    o.innerHTML=l;
    n.appendChild(o);

    n.list={};
    n.listlength=0;
    n.onmouseout =menu.fold_menuItem;
    n.onmouseover=menu.unfold_menuItem;
    menu.mainMenu_id.appendChild(n);
//    n.style.width=n.scrollWidth+"px"; // sets the size once and for all

    // create the folding list
    m.className="menuItemList";
    m.style.display="none";
    n.appendChild(m);
    n.menuItemList=m;

    return n;
  },


/////////////////////////////// Stupid code... but somewhat fun ///////////////////////////////

  rainbow_x:5,
  rainbow_i:0,

  iterate_rainbow:function(){ /* create a "rainbow" */
    var j=YGCSS.ColorStylesNames[--menu.rainbow_i];
    ygwm.new_window(j, null, "none", 160,90, menu.rainbow_x,
      Math.ceil((menu.rainbow_x/2)+60), false, true, true, true, false, j);
    menu.rainbow_x+=40;
    if (menu.rainbow_i>0)
      setTimeout(menu.iterate_rainbow,1);
  },

  key_count:0,
  key_time:0,

  iterate_keys:function(){
    if (menu.key_count>0) {
      setTimeout(menu.iterate_keys,1);
      winman.activate_window(winman.keys_list[--menu.key_count]);
    }
//    else
//    console.info(new Date().getTime()-menu.key_time);
//      console.info((+new Date())-menu.key_time);
  },

  create_menu:function(){
    (menu.mainMenu_id=dcE("DIV")).id="MainMenuBar";
    document.body.appendChild(menu.mainMenu_id);
  },

///////////////////////////////////////////////////////////////////////////
  // Build a YASEP-specific menu :
  init_obj: function(){

    var j, l='<a target="_blank" href="',
       v=l+'http://yasep.org/ygwm.mp4">',
       y=l+'gui-js/ygwm.html">';
    function t(i,k){
      menu.subMenuItem(j,i,k);
    }

  menu.create_menu();

  // this sequence makes a first layout to organise the menu,
  // before individual items are created, out of order.
    menu.mainMenuItem(["Doc","Doc"]);         /*TR-en*/ /*TR-fr*/
//    menu.mainMenuItem(["Tools","Outils"]); empty, items moved to other menus
//    menu.mainMenuItem(["Examples","Exemples"]); // To be (re)moved
    menu.mainMenuItem(["CPU/VHDL"]);
    menu.mainMenuItem(["ASM","Assembleur"]);  /*TR-en*//*TR-fr*/
    menu.mainMenuItem(["GNL"]);
//    menu.mainMenuItem(["BASIC"]);  http://hackaday.com/2011/08/28/basic-programming-on-an-arduino/ + Tinybasic.pde
//    menu.mainMenuItem(["Forth"]);
//    menu.mainMenuItem(["C"]);
//    menu.mainMenuItem(["Pascal"]);
    menu.mainMenuItem(["Dev","Dev","Desarrollo"]);

 // reverse order for the elements on the right side
  j=menu.mainMenuItem(["windows","fenêtres","ventanas"],"R"),      /*TR-en*//*TR-fr*//*TR-es*/
      t(["Welcome&nbsp;!", "Bienvenue&nbsp;!"], "welcome");  /*TR-en*//*TR-fr*/
      t(["Hide&nbsp;all","Cacher&nbsp;tout"],winlist.minimizeAll); /*TR-en*//*TR-fr*/
      t(["Show&nbsp;all","Montrer&nbsp;tout"],winlist.restoreAll); /*TR-en*//*TR-fr*/
      t(["Rainbow!","Arc&nbsp;en&nbsp;ciel"], function(){  /* create a "rainbow" */ /*TR-en*//*TR-fr*/
         menu.rainbow_i=YGCSS.ColorStylesNames.length;
         menu.iterate_rainbow();
      });
      t(["All&nbsp;windows","Ouvrir&nbsp;tout!"], function() { /*TR-en*//*TR-fr*/
        menu.key_time=+new Date(); //new Date().getTime();
        menu.key_count=winman.keys_list.length;
        menu.iterate_keys();
      });
      t([v+'Video&nbsp;demo</a>',v+'Démo&nbsp;vidéo</a>']);   /*TR-en*//*TR-fr*/
      t([y+'YGWM&nbsp;demo</a>',y+'Démo&nbsp;YGWM</a>']);      /*TR-en*//*TR-fr*/
  j=menu.mainMenuItem(["Web"],"R");
      t([l+'mailto:whygee%40f-cpu.org">Contact</a>']);         /*TR-en*//*TR-fr*/
      t([l+'yasep.tgz">Download</a>']);
      t([l+'license/agpl.txt">Licence</a>',l+'license/agpl.txt">License</a>']);  /*TR-en*//*TR-fr*/
      t([l+'http://yasep.org">yasep.org</a>']);
      t([l+'http://news.yasep.org/">blog</a>']);
      t([l+'https://www.facebook.com/pages/The-YASEP/167478153314916">facebook</a>']);
    menu.mainMenuItem(["LNG"],"R");
  }
});
